
/*******************************************************************************/
/* Copyright (C) 2013 Jonathan Moore Liles                                     */
/*                                                                             */
/* This program is free software; you can redistribute it and/or modify it     */
/* under the terms of the GNU General Public License as published by the       */
/* Free Software Foundation; either version 2 of the License, or (at your      */
/* option) any later version.                                                  */
/*                                                                             */
/* This program is distributed in the hope that it will be useful, but WITHOUT */
/* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or       */
/* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for   */
/* more details.                                                               */
/*                                                                             */
/* You should have received a copy of the GNU General Public License along     */
/* with This program; see the file COPYING.  If not,write to the Free Software */
/* Foundation, Inc., 51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.  */
/*******************************************************************************/

#pragma once

#include <FL/Fl_Slider.H>

class Fl_SliderX : public Fl_Slider
{
    bool _log;


public:

    void log ( bool v ) { _log = v; }
    bool log ( void ) const { return _log; }

    Fl_SliderX( int X, int Y, int W, int H, const char *L=0 ) : Fl_Slider(X,Y,W,H,L)
        {
	    _log = 0;
        }

    virtual ~Fl_SliderX (  ) { };

    virtual int slider_position ( double value, int w );
    virtual double slider_value ( int X, int w );

    virtual void draw ( int X, int Y, int W, int H );
    virtual void draw ( void ) { draw(x(),y(),w(),h()); }


    virtual int handle(int event, int X, int Y, int W, int H);
    virtual int handle(int event);
};
